zoukankan      html  css  js  c++  java
  • HDUOJ----Super Jumping! Jumping! Jumping!

    Super Jumping! Jumping! Jumping!

    Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
    Total Submission(s) : 5   Accepted Submission(s) : 1
    Problem Description
    Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



    The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
    Your task is to output the maximum value according to the given chessmen list.
     
    Input
    Input contains multiple test cases. Each test case is described in a line as follow:
    N value_1 value_2 …value_N
    It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
    A test case starting with 0 terminates the input and this test case is not to be processed.
     
    Output
    For each case, print the maximum according to rules, and one line one case.
     
    Sample Input
    3 1 3 2
    4 1 2 3 4
    4 3 3 2 1
    0
     
    Sample Output
    4
    10
    3
     
    Author
    lcy
     这道题,开始没怎么看懂,以为是连续的升段和,怎么这么简单,然后错了2边,后来发现是可以这样重组的....
    3 1 3 2 升段有{1},{3},{2},{1,3},{1,2}...所以最大是 4
    再比如 7 3 2 1 2 3 4 7  最大值为{1 2 3 4 7}=17.....这样话,关键是如何遍历找到他们的每一个数,对应的最大升段和....
    百度百科里有着一个公式;
     1 for(i=0;i<n;i++)
     2 {
     3     temp=0;
     4    for(j=0;j<i;j++)
     5    {
     6     if(arr[i]>arr[j]&&dp[j]>temp)
     7                    temp=dp[j];
     8     }
     9     dp[i]=temp+arr[i];
    10 }


    上面的公式,运用的范围极为广泛....注意记下来!!

    代码如下:

     1 #include<iostream>
     2 #include<vector>
     3 using namespace std;
     4 int main()
     5 {
     6     int n,i,j,temp;
     7     while(cin>>n,n)
     8     {
     9        vector<int>arr(n,0);
    10        vector<int>dp(n,0);
    11        for(i=0;i<n;i++)
    12        {
    13            cin>>arr[i];
    14        }
    15        int max=0;
    16        for(i=0;i<n;i++)
    17        {   
    18            temp=0;
    19            for(j=0;j<i;j++)
    20            {
    21                if(arr[i]>arr[j]&&dp[j]>temp)
    22                    temp=dp[j];
    23            }
    24            dp[i]=temp+arr[i];
    25            
    26            max=max>dp[i]?max:dp[i];
    27        }
    28        cout<<max<<endl;
    29     }
    30  return 0;
    31 }
    View Code
     
  • 相关阅读:
    【POJ1961】period
    主席树入门
    noip模拟【tea】
    noip模拟【service】
    noip模拟【noname】
    clearfix清除浮动
    九大内置对象
    2017/10/10 jar包错误
    mybatis案例源码详解
    自动类型转换
  • 原文地址:https://www.cnblogs.com/gongxijun/p/3239226.html
Copyright © 2011-2022 走看看